package fr.inria.phoenix.diasuite.diaswarm.generator.template

import java.util.List

class DiaSwarmEntity {

	// Used to keep track of generated code
	//private HashMap<String, Set<String>> files = new HashMap<String, Set<String>>();	
    
	def equalsAndHashCode(String className, List<String> variableNames) '''
        @Override
        public int hashCode() {
            final int prime = 31;
            int result = 1;
            «FOR variableName: variableNames.map[toFirstLower]»
            result = prime * result + ((«variableName» == null) ? 0 : «variableName».hashCode());
            «ENDFOR»
            return result;
        }
        
        @Override
        public boolean equals(Object obj) {
            if (this == obj)
                return true;
            if (obj == null)
                return false;
            if (getClass() != obj.getClass())
                return false;
            «className» other = («className») obj;
            «FOR variableName: variableNames.map[toFirstLower]»
            if («variableName» == null) {
                if (other.«variableName» != null)
                    return false;
            } else if (!«variableName».equals(other.«variableName»))
                return false;
            «ENDFOR»
            return true;
        }
    '''

}